#ifndef _CODE_MOUSE_POINTERS_CPP_
#define _CODE_MOUSE_POINTERS_CPP_

/* XPM */

static const char* mouseArrow[ ] = {
  /* width height num_colors chars_per_pixel */
  "    32    32        3            1",
  /* colors */
  "X c #000000",
  ". c #ffffff",
  "  c None",
  /* pixels */
  "X                               ",
  "XX                              ",
  "X.X                             ",
  "X..X                            ",
  "X...X                           ",
  "X....X                          ",
  "X.....X                         ",
  "X......X                        ",
  "X.......X                       ",
  "X........X                      ",
  "X....XXXXXX                     ",
  "X...X                           ",
  "X..X                            ",
  "X.X                             ",
  "XX                              ",
  "X                               ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "0,0"
};

static const char* mouseCrosshair[ ] = {
  /* width height num_colors chars_per_pixel */
  "    32    32        3            1",
  /* colors */
  "X c #000000",
  ". c #ffffff",
  "  c None",
  /* pixels */
  "         X                      ",
  "         .                      ",
  "         X                      ",
  "         .                      ",
  "         X                      ",
  "         .                      ",
  "         X                      ",
  "         .                      ",
  "                                ",
  "X.X.X.X.   .X.X.X.X             ",
  "                                ",
  "         .                      ",
  "         X                      ",
  "         .                      ",
  "         X                      ",
  "         .                      ",
  "         X                      ",
  "         .                      ",
  "         X                      ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "9,9"
};

static const char* mouseBusy[ ] = {
  /* width height num_colors chars_per_pixel */
  "    32    32        3            1",
  /* colors */
  "X c #000000",
  ". c #ffffff",
  "  c None",
  /* pixels */
  "                                ",
  "                                ",
  "    ......                      ",
  "     XXX.XX                     ",
  "       .XX                      ",
  "      .XX                       ",
  "     .XX                        ",
  "    ......                      ",
  "     XXXXXX                     ",
  "            ......              ",
  "             XXX.XX             ",
  "               .XX              ",
  "......        .XX               ",
  " XXX.XX      .XX                ",
  "   .XX      ......              ",
  "  .XX        XXXXXX             ",
  " .XX                            ",
  "......                          ",
  " XXXXXX                         ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "9,9"
};

static void setCursor( const char* Image[ ] )
{
  int i, row, col;
  Uint8 data[ 4 * 32 ];
  Uint8 mask[ 4 * 32 ];
  int hot_x, hot_y;

  i = -1;
  for ( row=0; row<32; ++row ) 
  {
    for ( col=0; col<32; ++col ) 
    {
      if ( col % 8 ) 
      {
        data[ i ] <<= 1;
        mask[ i ] <<= 1;
      } 
      else 
      {
        ++i;
        data[ i ] = mask[ i ] = 0;
      }
      switch ( Image[ 4 + row ][ col ] ) 
      {
        case 'X':
          data[ i ] |= 0x01;
          mask[ i ] |= 0x01;
          break;
        case '.':
          mask[ i ] |= 0x01;
          break;
        case ' ':
          break;
      }
    }
  }
  sscanf( Image[ 4 + row ], "%d,%d", &hot_x, &hot_y );
  SDL_Cursor* currentCursor = SDL_CreateCursor( data, mask, 32, 32, hot_x, hot_y );
  SDL_SetCursor ( currentCursor ); 
}

#endif
