#ifndef _CODE_SDLGFX_CPP_
#define _CODE_SDLGFX_CPP_

#include <SDL/SDL.h>
#include <iostream>

using namespace std;

inline void putSDLPixel ( int x, int y, Uint32 pixel, SDL_Surface* surface )
{		
	if ( x >= 0 & x < surface->w & y >= 0 & y < surface->h )
	{																
		/* 
			Here p is the address to the pixel we want to set 
		*/
		Uint8* p = ( Uint8* )( surface->pixels ) + y * surface->pitch + x * surface->format->BytesPerPixel;	

		switch( surface->format->BytesPerPixel ) 
		{
			case 1:
				*p = pixel;
				break;			
			case 2:
				*( Uint16* )p = pixel;
				break;			
			case 3:
				if( SDL_BYTEORDER == SDL_BIG_ENDIAN ) 
				{
					p[ 0 ] = ( pixel >> 16 ) & 0xff;
					p[ 1 ] = ( pixel >> 8 ) & 0xff;
					p[ 2 ] = pixel & 0xff;
				} 
				else 
				{
					p[ 0 ] = pixel & 0xff;
					p[ 1 ] = ( pixel >> 8 ) & 0xff;
					p[ 2 ] = ( pixel >> 16 ) & 0xff;
				}
				break;			
			case 4:
				*( Uint32* )p = pixel;
				break;
		}
	}		
}
#endif
