#include "cFileDialogue.h"
#include "../globalcode/datadir.h"

cFileDialogue::cFileDialogue ( )
{
	sCurrentDirectory = "/";
	sFileName = "";
	
	if ( SDL_BYTEORDER == SDL_BIG_ENDIAN )
	{
		iRmask = 0xff000000;
		iGmask = 0x00ff0000;
		iBmask = 0x0000ff00;
		iAmask = 0x000000ff;
	}
	else
	{
		iRmask = 0x000000ff;
		iGmask = 0x0000ff00;
		iBmask = 0x00ff0000;
		iAmask = 0xff000000;
	}			
	
	TTF_Init ( );
	
        std::string file = get_datadir() + std::string("/bitstream_vera_sans.ttf");
 	oFont = TTF_OpenFont ( file.c_str (), 12 );
		
	iRowHeight = 16;	
	iScrollbarWidth = 16;
	iScrollbarHeight = 1;
	iPosition = 0;		
	iScrollHeight = 0;					
}

cFileDialogue::~cFileDialogue ( )
{
	
}

void cFileDialogue::setOutputSurface ( SDL_Surface* surface )
{
	oSurface = surface;	
	
	oCol1.r = 255; oCol1.g = 255; oCol1.b = 255;
	oCol2.r = 225; oCol2.g = 225; oCol2.b = 225;
	oCol3.r =  55; oCol3.g =  55; oCol3.b =  55;
	oCol4.r =  45; oCol4.g =  45; oCol4.b =  45;		
	
	oUol1 = SDL_MapRGBA ( oSurface->format, 55, 55, 55, 255 );
	oUol2 = SDL_MapRGBA ( oSurface->format, 45, 45, 45, 255 );
	
	iScrollHeight = oSurface->h - 64;
	
	SDL_Rect strRect = { 16, iScrollHeight + 32, oSurface->w - 32 - 184, 16 };
	oString.setRect ( strRect );
	oString.setString ( sFileName );	
	oString.setDisplaySurface ( oSurface );
	
	strRect = ( SDL_Rect ){ oSurface->w - 32 - 184 + 32, iScrollHeight + 32, 64, 16 };
	oButtonOk.setDisplaySurface ( oSurface );
	oButtonOk.setRect ( strRect );
	oButtonOk.setText ( "OK" );	
	
	strRect = ( SDL_Rect ){ oSurface->w - 32 - 184 + 32 + 64 + 16, iScrollHeight + 32, 88, 16 };	
	oButtonCancel.setDisplaySurface ( oSurface );
	oButtonCancel.setRect ( strRect );
	oButtonCancel.setText ( "Cancel" );
}

string cFileDialogue::getFileName ( )
{		
	/*
		Set current selected file
	*/	
	sCurrentFilename = "";
	
	/*
		Clear screen: 
	*/
	
	Uint32 bc = SDL_MapRGBA( oSurface->format, 20, 20, 20, 255 );	
	SDL_Rect rect = { 0, 0, oSurface->w, oSurface->h };	
	SDL_FillRect ( oSurface, &rect, bc );	
	
	/*
		We're running..
	*/
	bool running = true;		 
	
	
	/*
		Read current working directory and draw it:
	*/	
	
	readCurrentDirectory ( );			
	
	refresh ( );		
	
	oButtonOk.reset ( );
	oButtonCancel.reset ( );
	
	/*
		Main loop:
	*/
	
	int imx = 0; int imy = 0;
	int prevp;
		
	bool switcher;	
	
	while ( running )
	{	
		if ( SDL_PollEvent ( &oEvent ) )
		{
			switch ( oEvent.type )
			{
				case SDL_MOUSEBUTTONDOWN:																				
															
					oButtonOk.Click ( imx, imy );
					oButtonCancel.Click ( imx, imy );
															
					if ( imx > 16 && imx < oSurface->w - 32 - 184 && imy > iScrollHeight + 16 & imy < oSurface->h - 16 )
					{
						oString.setActive ( );	
						sCurrentFilename = oString.getString ( );				
					}									
					else if ( imx < oSurface->w - 16 )
					{
						string tempString; 
						
						tempString = sCurrentDirectory + mFiles[ iPosition ];
						
						struct stat info;
						
						stat ( tempString.c_str ( ), &info );
						
						/*
							if the file is a directory, cd into it:
						*/					
							
						if ( mFiles[ iPosition ] == ".." )
						{
							string prosString = "";														
							
							bool firstSlash = false;
							
							for ( int a = sCurrentDirectory.size ( ) - 2; a >= 0; a-- )
							{
								if ( sCurrentDirectory.substr ( a, 1 ) == "/" && !firstSlash )
								{									
									firstSlash = true;
								}
								if ( firstSlash )
								{
									prosString = sCurrentDirectory.substr ( a, 1 ) + prosString;
								}
							}
							
							if ( prosString.substr ( 0, 1 ) == "/" )
							{
								/* Clear (move to clear() function later) */
								Uint32 bc = SDL_MapRGBA( oSurface->format, 20, 20, 20, 255 );	
								SDL_Rect rect = { 0, 0, oSurface->w, oSurface->h };	
								SDL_FillRect ( oSurface, &rect, bc );									
								mFiles.clear ( );
								sCurrentDirectory = prosString; 								
								readCurrentDirectory ( );
								refresh ( );
							}							
						}
						else if ( mFiles[ iPosition ] == "." )
						{
							cout << "Do nothing" << endl;
						}						
						else if ( S_ISDIR ( info.st_mode ) )
						{
							/* Clear (move to clear() function later) */
							Uint32 bc = SDL_MapRGBA( oSurface->format, 20, 20, 20, 255 );	
							SDL_Rect rect = { 0, 0, oSurface->w, oSurface->h };	
							SDL_FillRect ( oSurface, &rect, bc );	
							mFiles.clear ( );
							sCurrentDirectory = tempString + "/";
							readCurrentDirectory ( );							
							refresh ( );
						}		
						else
						{
							string outString;
							for ( int a = 0; a < ( int )tempString.size ( ); a++ )
							{								
								if ( tempString.substr ( a, 1 ) == "/" )
									outString.clear ( );
								else
									outString += tempString.substr ( a, 1 );
							}
							oString.setString ( outString );
						}																			
					}
					else
					{
						/*
							Scrollbar controls - while the mouse is down
						*/												
						
						if ( imy >= iOffsetY & imy <= iOffsetY + iScrollbarHeight )
						{

							bool mouseUp = false;
							
							int mouseOffsetY = imy - iOffsetY;
							
							while ( !mouseUp )
							{																
								SDL_GetMouseState ( &imx, &imy );								
								
								iOffsetY = imy - mouseOffsetY;
								
								if ( iOffsetY < 0 )
								{
									iOffsetY = 0;
								}
								else if ( iOffsetY > ( iScrollHeight - iScrollbarHeight ) )				
								{
									iOffsetY = iScrollHeight - iScrollbarHeight;
								}
																								
								while ( SDL_PollEvent ( &oEvent ) )
								{
									switch ( oEvent.type )
									{
										case SDL_MOUSEBUTTONUP:
											mouseUp = true;
											break;
									}
								}
								
								refresh ( );																																																
																
								SDL_Delay ( 2 );
							}		
										
						}
					}
					
					break;
					
				case SDL_KEYDOWN:
						switch ( oEvent.key.keysym.sym )
						{
							case SDLK_ESCAPE:
								running = false;
								break;
								
							default: break;
						}
					break;
				
				default: break;
			}
		
			SDL_GetMouseState ( &imx, &imy );
			
			oButtonOk.isMouseOver ( imx, imy );
			oButtonCancel.isMouseOver ( imx, imy );
			
			unsigned int start = floor ( ( double )iOffsetY / iScrollHeight * iTotalCount );
			
			iPosition = floor( ( double )imy / iRowHeight ) + start;
					
			if ( iPosition != prevp & iPosition - start <= ( ( iScrollHeight - iRowHeight ) / iRowHeight ) )
			{				
				int iRealPosition = floor ( ( double )imy / iRowHeight ) * iRowHeight + 1;								
				
				if ( mFiles[ iPosition ].size ( ) )
				{								
					refresh ( );
					
					SDL_Rect tmprect = { 0, iRealPosition - 1, oSurface->w - iScrollbarWidth, iRowHeight };										
					
					SDL_FillRect ( oSurface, &tmprect, SDL_MapRGBA ( oSurface->format, 100, 100, 100, 255 ) );										
					
					if ( mFiles[ iPosition ].size ( ) )
					{
						SDL_Surface* textSurf = TTF_RenderText_Blended ( oFont, mFiles[ iPosition ].c_str ( ), oCol1 );
						SDL_Rect rect = { 4, iRealPosition, textSurf->w, textSurf->h };
						SDL_BlitSurface ( textSurf, NULL, oSurface, &rect );				
						SDL_FreeSurface ( textSurf );
					}
					SDL_Flip ( oSurface );
				}			
			}
			/* Record last hovered row */
			prevp = iPosition;
			SDL_Delay ( 2 );
		}
		else
			SDL_Delay ( 50 );						
			
		if ( oButtonOk.isClicked ( ) )
		{
			sCurrentFilename = sCurrentDirectory + "/" + oString.getString ( );
			running = false;
		}
		else if ( oButtonCancel.isClicked ( ) )
		{
			sCurrentFilename = "";
			running = false;
		}
	}
	
	return sCurrentFilename;
}

void cFileDialogue::readCurrentDirectory ( )
{		
	DIR* dir;		
	
	iOffsetY = 0; // Show the directory top down					
	
	struct dirent* entry;				
	
	if ( ( dir = opendir( sCurrentDirectory.c_str ( ) ) ) == NULL )
	{
		cout << "Could not open directory. Give error about permissions." << endl;
	}					
	
	iTotalCount = 0;
	
	while ( ( entry = readdir ( dir ) ) != NULL )
	{		
		mFiles[ iTotalCount ] = ( string )entry->d_name;
			
		iTotalCount++;						
	}		
	
	closedir( dir );
}
	
void cFileDialogue::refresh ( )
{				
	drawScrollbar ( );
		
	oString.refresh ( );
	
	oButtonOk.refresh ( );
	
	oButtonCancel.refresh ( );
			
	bool switcher = 0;
				
	unsigned int start = floor ( ( double )iOffsetY / iScrollHeight * iTotalCount );	
	
	int limit = 30; 
	
	int counter = 0;							
		
	for ( 
		int a = start; 
		( counter * iRowHeight ) + iRowHeight <= ( iScrollHeight ); 
		a++ 
	)
	{			
		SDL_Surface* textSurf;
		
		SDL_Rect rectU = { 0, counter * iRowHeight, oSurface->w - iScrollbarWidth, iRowHeight };
		
		if ( switcher == 0 )
		{			
			SDL_FillRect ( oSurface, &rectU, oUol1 );
			if ( mFiles[ a ].size ( ) )
				textSurf = TTF_RenderText_Shaded ( oFont, mFiles[ a ].c_str ( ), oCol2, oCol3 );
			switcher = 1;
		}
		else
		{			
			SDL_FillRect ( oSurface, &rectU, oUol2 );
			if ( mFiles[ a ].size ( ) )			
				textSurf = TTF_RenderText_Shaded ( oFont, mFiles[ a ].c_str ( ), oCol2, oCol4 );			
			switcher = 0;
		}														
		
		if ( mFiles[ a ].size ( ) )
		{
			SDL_Rect rect; rect.x = 4; rect.y = rectU.y + 1; rect.w = textSurf->w; rect.h = textSurf->h;			
			SDL_BlitSurface ( textSurf, NULL, oSurface, &rect );								
		}													
		counter++;
	}	
	SDL_Flip ( oSurface );
}

/*
	Draw the scrollbar at it's position;
	(later add arrow gadgets and calculate in their subtractions
*/
void cFileDialogue::drawScrollbar ( )
{
	int scrollbarHeight = 0; // The visual height of the scrollbar
	int totalHeight = ( iRowHeight * iTotalCount );
	int offPageH = totalHeight - ( iScrollHeight ); // <- What is outside

	if ( totalHeight > ( iScrollHeight ) )
	{		
		scrollbarHeight = round ( ( float )offPageH / totalHeight * ( iScrollHeight ) );
		iScrollRelativeHeight = ( ( iScrollHeight ) - scrollbarHeight );
	}
	else
	{
		scrollbarHeight = ( iScrollHeight );
		iScrollRelativeHeight = 0;
	}
	
	Uint32 colorB = SDL_MapRGBA ( oSurface->format, 0, 0, 0, 255 );
 	Uint32 colorW = SDL_MapRGBA ( oSurface->format, 255, 255, 255, 255 );
	
	SDL_Rect rClear = { oSurface->w - iScrollbarWidth, 0, iScrollbarWidth, iScrollHeight };
	SDL_Rect rScrollbar = { oSurface->w - iScrollbarWidth, iOffsetY, iScrollbarWidth, scrollbarHeight };
	
	SDL_FillRect ( oSurface, &rClear, colorB );
	SDL_FillRect ( oSurface, &rScrollbar, colorW );
	
	iScrollbarHeight = scrollbarHeight;
}
