#ifndef _CFILEDIALOGUE_H_
#define _CFILEDIALOGUE_H_

#include <string>
#include <sstream>
#include <dirent.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <iostream>
#include <map>
#include <cmath>

#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>

#include "cGadgetString.h"
#include "cGadgetButton.h"

using namespace std;

class cFileDialogue
{
	private:
		
		TTF_Font* oFont;
		
		string sCurrentDirectory;
		string sFileName;
		string sCurrentFilename;
		
		int iFileCount;				// How many FILEs are there
		int iDirCount;				// How many folders are there
		int iTotalCount;			// How many files and folders are there
		int iRowHeight;				// The height of a file row in pixels		
		int iOffsetY;					// Where is the scrollbar?
		int iScrollbarWidth;	// The width of the scrollbar..
		int iScrollbarHeight; // The height of the scrollbar...
		int iPosition;				// The current position of mFiles;
		int iScrollRelativeHeight; // How much of the screen we scroll
		int iScrollHeight; 		// How far scrolling can go				
		
		map < int, string > mFiles;
		
		Uint8* iKey;
		
		SDL_Event oEvent;
		SDL_Surface* oSurface;
		SDL_Surface* oBuffer;
		cGadgetString oString;
		cGadgetButton oButtonOk;
		cGadgetButton oButtonCancel;		
		
		SDL_Color oCol1, oCol2, oCol3, oCol4;
		Uint32 oUol1, oUol2;
		
		Uint32 iAmask, iRmask, iGmask, iBmask;
		
	public:
		cFileDialogue ( );
		~cFileDialogue ( );
		
		string getFileName ( );
		
		void setOutputSurface ( SDL_Surface* surface );		
		void readCurrentDirectory ( );
		void refresh ();
		void drawScrollbar ( );
};

#endif
