#include "cGadgetButton.h"
#include "../globalcode/datadir.h"

cGadgetButton::cGadgetButton ( )
{	
	iX = 0; iY = 0; iWidth = 1; iHeight = 1;		
		
	bIsClicked = false;
	
	TTF_Init ( );

        std::string file = get_datadir() + std::string("/bitstream_vera_sans.ttf");
 	oFont = TTF_OpenFont (file.c_str(), 12 );
}

cGadgetButton::~cGadgetButton ( )
{
	bIsClicked = false;
}

void cGadgetButton::setDisplaySurface ( SDL_Surface* surface )
{
	oSurface = surface;
	iBackgroundColor = SDL_MapRGBA ( oSurface->format, 128, 128, 128, 255 );
}

void cGadgetButton::setRect ( SDL_Rect rect )
{
	iX = rect.x; iY = rect.y;
	iWidth = rect.w; iHeight = rect.h;
}

void cGadgetButton::setText ( string stext )
{
	sText = stext;	
}

void cGadgetButton::Click ( int x, int y )
{
	if ( isMouseOver ( x, y ) )
	{
		bIsClicked = true;
	}
}

void cGadgetButton::refresh ( )
{
	SDL_Rect rect = { iX, iY, iWidth, iHeight };	
	SDL_FillRect ( oSurface, &rect, iBackgroundColor );
	
	SDL_Color colorB = { 0, 0, 0, 255 };
	
	SDL_Surface* textSurf = TTF_RenderText_Blended ( oFont, sText.c_str ( ), colorB );		
	rect = ( SDL_Rect ){ iX + ( int )( ( double )iWidth / 2 ) - ( int )( ( double )textSurf->w / 2 ), iY + ( int )( ( double )iHeight / 2 ) - ( int )( ( double )textSurf->h / 2 ), textSurf->w, textSurf->h };
	SDL_BlitSurface ( textSurf, NULL, oSurface, &rect );				
	SDL_FreeSurface ( textSurf );
		
	for ( int x = iX; x < iX + iWidth; x++ )
	{
		if ( x == iX || x == iX + iWidth - 1 )
		{
			putSDLPixel ( x, iY, SDL_MapRGBA ( oSurface->format, 128, 128, 128, 255 ), oSurface );
			putSDLPixel ( x, iY + iHeight - 1, SDL_MapRGBA ( oSurface->format, 28, 28, 28, 255 ), oSurface );
		}
		else
		{
			putSDLPixel ( x, iY, SDL_MapRGBA ( oSurface->format, 255, 255, 255, 255 ), oSurface );
			putSDLPixel ( x, iY + iHeight - 1, SDL_MapRGBA ( oSurface->format, 64, 64, 64, 255 ), oSurface );
		}
	}
	for ( int y = iY; y < iY + iHeight; y++ )
	{
		if ( y == iY || y == iY + iHeight - 1 )
		{
			putSDLPixel ( iX, y, SDL_MapRGBA ( oSurface->format, 128, 128, 128, 255 ), oSurface );
			putSDLPixel ( iX + iWidth - 1, y, SDL_MapRGBA ( oSurface->format, 28, 28, 28, 255 ), oSurface );
		}
		else
		{
			putSDLPixel ( iX, y, SDL_MapRGBA ( oSurface->format, 255, 255, 255, 255 ), oSurface );
			putSDLPixel ( iX + iWidth - 1, y, SDL_MapRGBA ( oSurface->format, 64, 64, 64, 255 ), oSurface );
		}
	}
	
	SDL_UpdateRect ( oSurface, iX, iY, iWidth ,iHeight );
}

bool cGadgetButton::isMouseOver ( int x, int y )
{
	if ( x >= iX && y >= iY && x < iX + iWidth && y < iY + iHeight )
	{
		iBackgroundColor = SDL_MapRGBA ( oSurface->format, 255, 128, 128, 255 );
		refresh ( );
		return true;
	}
	else
	{
		iBackgroundColor = SDL_MapRGBA ( oSurface->format, 128, 128, 128, 255 );
		refresh ( );
		return false;
	}
}

bool cGadgetButton::isClicked ( )
{	
	return bIsClicked;	
}

void cGadgetButton::reset ( )
{
	bIsClicked = false;
}

void cGadgetButton::setX ( int x )
{
	iX = x;
}

void cGadgetButton::setY ( int y )
{
	iY = y;
}

void cGadgetButton::setWidth ( int width )
{
	iWidth = width;
}

void cGadgetButton::setHeight ( int height )
{
	iHeight = height;
}

int cGadgetButton::getX ( )
{
	return iX;
}

int cGadgetButton::getY ( )
{
	return iY;
}

int cGadgetButton::getWidth ( )
{
	return iWidth;
}

int cGadgetButton::getHeight ( )
{
	return iHeight;
}
