#ifndef _CGADGETBUTTON_H_
#define _CGADGETBUTTON_H_

#include <iostream>
#include <string>
#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>

#include "../globalcode/code_sdlgfx.cpp"

using namespace std;

class cGadgetButton
{
	private:
	
		string sText;
		
		int iX, iY, iWidth, iHeight;
		
		/* If the button is clicked at all - special case */
		bool bIsClicked;				
	
		SDL_Surface* oSurface;
		
		Uint32 iBackgroundColor;
		
		TTF_Font* oFont;		
	
	public:
	
		cGadgetButton ( );
		~cGadgetButton ( );
		
		void setDisplaySurface ( SDL_Surface* surface );
		
		void setRect ( SDL_Rect rect );
		
		void setText ( string stext );
		
		void refresh ( );
		
		bool isMouseOver ( int x, int y );
		
		bool isClicked ( );	
		
		void Click ( int x, int y );
		
		void reset ( );
		
		void setX ( int x );
		void setY ( int y );	
		void setWidth ( int width );
		void setHeight ( int height );	
			
		int getX ( );		
		int getY ( );
		int getWidth ( );
		int getHeight ( );
		
};

#endif
