#include "cGadgetImageButton.h"


cGadgetImageButton::cGadgetImageButton ( )
{	
	iX = 0; iY = 0; iWidth = 1; iHeight = 1;		
		
	bIsClicked = false;	
}

cGadgetImageButton::~cGadgetImageButton ( )
{
	bIsClicked = false;
}

void cGadgetImageButton::setDisplaySurface ( SDL_Surface* surface )
{
	oSurface = surface;
	iBackgroundColor = SDL_MapRGBA ( oSurface->format, 128, 128, 128, 255 );
}

void cGadgetImageButton::setRect ( SDL_Rect rect )
{
	iX = rect.x; iY = rect.y;
	iWidth = rect.w; iHeight = rect.h;
}

void cGadgetImageButton::setImage ( string simage )
{
	oImageSurface = IMG_Load ( simage.c_str ( ) );	
}

void cGadgetImageButton::Click ( int x, int y )
{
	if ( isMouseOver ( x, y ) )
	{
		bIsClicked = true;
	}
}

void cGadgetImageButton::refresh ( )
{
	SDL_Rect rect = { iX, iY, iWidth, iHeight };	
	SDL_FillRect ( oSurface, &rect, iBackgroundColor );
	
	SDL_Color colorB = { 0, 0, 0, 255 };
		
	SDL_Rect dest = 
	{ 
		iX + ( ( double )iWidth / 2 ) - ( ( double )oImageSurface->w / 2 ),
		iY + ( ( double )iHeight / 2 ) - ( ( double )oImageSurface->h / 2 ),
		oImageSurface->w, oImageSurface->h
	};
	SDL_BlitSurface ( oImageSurface, NULL, oSurface, &dest );
	
		
	for ( int x = iX; x < iX + iWidth; x++ )
	{
		if ( x == iX || x == iX + iWidth - 1 )
		{
			putSDLPixel ( x, iY, SDL_MapRGBA ( oSurface->format, 128, 128, 128, 255 ), oSurface );
			putSDLPixel ( x, iY + iHeight - 1, SDL_MapRGBA ( oSurface->format, 28, 28, 28, 255 ), oSurface );
		}
		else
		{
			putSDLPixel ( x, iY, SDL_MapRGBA ( oSurface->format, 255, 255, 255, 255 ), oSurface );
			putSDLPixel ( x, iY + iHeight - 1, SDL_MapRGBA ( oSurface->format, 64, 64, 64, 255 ), oSurface );
		}
	}
	for ( int y = iY; y < iY + iHeight; y++ )
	{
		if ( y == iY || y == iY + iHeight - 1 )
		{
			putSDLPixel ( iX, y, SDL_MapRGBA ( oSurface->format, 128, 128, 128, 255 ), oSurface );
			putSDLPixel ( iX + iWidth - 1, y, SDL_MapRGBA ( oSurface->format, 28, 28, 28, 255 ), oSurface );
		}
		else
		{
			putSDLPixel ( iX, y, SDL_MapRGBA ( oSurface->format, 255, 255, 255, 255 ), oSurface );
			putSDLPixel ( iX + iWidth - 1, y, SDL_MapRGBA ( oSurface->format, 64, 64, 64, 255 ), oSurface );
		}
	}
	
	SDL_UpdateRect ( oSurface, iX, iY, iWidth ,iHeight );
}

bool cGadgetImageButton::isMouseOver ( int x, int y )
{
	if ( x >= iX && y >= iY && x < iX + iWidth && y < iY + iHeight )
	{
		iBackgroundColor = SDL_MapRGBA ( oSurface->format, 255, 128, 128, 255 );
		refresh ( );
		return true;
	}
	else
	{
		iBackgroundColor = SDL_MapRGBA ( oSurface->format, 128, 128, 128, 255 );
		refresh ( );
		return false;
	}
}

bool cGadgetImageButton::isClicked ( )
{	
	return bIsClicked;	
}

void cGadgetImageButton::reset ( )
{
	bIsClicked = false;
}

void cGadgetImageButton::setX ( int x )
{
	iX = x;
}

void cGadgetImageButton::setY ( int y )
{
	iY = y;
}

void cGadgetImageButton::setWidth ( int width )
{
	iWidth = width;
}

void cGadgetImageButton::setHeight ( int height )
{
	iHeight = height;
}

int cGadgetImageButton::getX ( )
{
	return iX;
}

int cGadgetImageButton::getY ( )
{
	return iY;
}

int cGadgetImageButton::getWidth ( )
{
	return iWidth;
}

int cGadgetImageButton::getHeight ( )
{
	return iHeight;
}
