#ifndef _CGADGETIMAGEBUTTON_H_
#define _CGADGETIMAGEBUTTON_H_

#include <iostream>
#include <string>
#include <SDL/SDL.h>
#include <SDL/SDL_image.h>

#include "../globalcode/code_sdlgfx.cpp"

using namespace std;

class cGadgetImageButton
{
	private:
	
		string sImageName;
		
		int iX, iY, iWidth, iHeight;
		
		/* If the button is clicked at all - special case */
		bool bIsClicked;				
	
		SDL_Surface* oSurface;
		SDL_Surface* oImageSurface;
		
		Uint32 iBackgroundColor;		
	
	public:
	
		cGadgetImageButton ( );
		~cGadgetImageButton ( );
		
		void setDisplaySurface ( SDL_Surface* surface );
		
		void setRect ( SDL_Rect rect );
		
		void setX ( int x );
		void setY ( int y );	
		void setWidth ( int width );
		void setHeight ( int height );	
			
		int getX ( );		
		int getY ( );
		int getWidth ( );
		int getHeight ( );
		
		void setImage ( string simage );
		
		void refresh ( );
		
		bool isMouseOver ( int x, int y );
		
		bool isClicked ( );	
		
		void Click ( int x, int y );
		
		void reset ( );
};

#endif
