#include "cGadgetSlider.h"

cGadgetSlider::cGadgetSlider ( )
{
 	iX = 0; 
	iY = 0; 
	iWidth = 1; 
	iHeight = 1;
	sDirection = "x";
	fMax = 1; 
	fMin = 0; 
	fValue = 0;
	iEventMouseCoordX = 0;
	iEventMouseCoordY = 0;
}

cGadgetSlider::~cGadgetSlider ( ){}

void cGadgetSlider::setActive ( )
{
	if ( oButton.isMouseOver ( iEventMouseCoordX, iEventMouseCoordY ) )
		mainLoop ( );
}

void cGadgetSlider::setDirection ( string direction )
{	
	if ( direction == "x" || direction == "y" ) sDirection = direction;
}

void cGadgetSlider::setDisplaySurface ( SDL_Surface* surface )
{
	oSurface = surface;
	oButton.setDisplaySurface ( surface );	
	oButton.setText ( " " );
}

void cGadgetSlider::setButtonRect ( SDL_Rect rect )
{
	oButton.setRect ( rect );
}

void cGadgetSlider::setSliderRect ( SDL_Rect rect )
{
	iX = rect.x; iY = rect.y; iWidth = rect.w; iHeight = rect.h;
}

void cGadgetSlider::setScope ( float min, float max )
{
	fMin = min; fMax = max;
}

void cGadgetSlider::setValue ( float value )
{
	fValue = value;
}

bool cGadgetSlider::isMouseOver ( int x, int y )
{
	if ( x >= iX & x < iX + iWidth & y >= iY & y < iY + iHeight )
	{
		oButton.isMouseOver ( x, y );
		iEventMouseCoordX = x; 
		iEventMouseCoordY = y;
		return true;
	}
	return false;
}

float cGadgetSlider::getValue ( )
{
	return fValue;
}

void cGadgetSlider::refresh ( )
{	
	oButton.setX ( iX + ( int )( fValue / ( fMax - fMin ) * ( iWidth - oButton.getWidth ( ) ) ) );	
		
	SDL_Rect backgroundRect = { iX, iY, iWidth, iHeight };
	SDL_FillRect ( oSurface, &backgroundRect, SDL_MapRGB ( oSurface->format, 128, 128, 128 ) );
	
	/* If we're making a horizontal scroller */
	if ( sDirection == "x" )
	{				
		int midHeight = round( ( double )iHeight / 2 );				
		
		for ( int a = 0; a < iWidth; a++ )
		{
			putSDLPixel ( iX + a, iY + midHeight - 1, 
										SDL_MapRGBA ( oSurface->format, 0, 0, 0, 255 ), oSurface 
			);
			putSDLPixel ( iX + a, iY + midHeight + 1, 
										SDL_MapRGBA ( oSurface->format, 255, 255, 255, 255 ), oSurface 
			);
			putSDLPixel ( iX + a, iY + midHeight, 
										SDL_MapRGBA ( oSurface->format, 128, 128, 128, 255 ), oSurface
			);
		}
		putSDLPixel ( iX, iY + midHeight,
									SDL_MapRGBA ( oSurface->format, 0, 0, 0, 255 ), oSurface
		);
		putSDLPixel ( iX + iWidth - 1, iY + midHeight,
									SDL_MapRGBA ( oSurface->format, 255, 255, 255, 255 ), oSurface
		);
	}
	/* If we're making a vertical scroller */ /* to be done */
	
	/* Draw button */		
	stringstream stri; stri << round ( fValue );
	oButton.setText ( stri.str ( ) );
	oButton.refresh ( );
	
	SDL_UpdateRect ( oSurface, iX, iY, iWidth, iHeight );
}

void cGadgetSlider::mainLoop ( )
{
	bool mouseUp = false;
						
	int imx, imy;
	
	SDL_GetMouseState ( &imx, &imy );			
	
	int OffsetX = imx - oButton.getX ( );
	int OffsetY = imy - oButton.getY ( );		
	
	SDL_Event oEvent;
	
	while ( !mouseUp )
	{																
		SDL_GetMouseState ( &imx, &imy );		
		
		if ( imx - OffsetX < iX )
		{			
			oButton.setX ( iX );
		}
		else if ( imx - OffsetX > iX + iWidth - oButton.getWidth ( ) )
		{
			oButton.setX ( iX + iWidth - oButton.getWidth ( ) );
		}
		else
		{			
			oButton.setX ( imx - OffsetX );
		}	
					
		if ( imy - OffsetY < iY )
		{
			oButton.setY ( iY );
		}
		else if ( imy - OffsetY > iY + iHeight - oButton.getHeight ( ) )
		{
			oButton.setY ( iY + iHeight - oButton.getHeight ( ) );
		}
		else
		{
			oButton.setY ( imy - OffsetY );
		}	
			
		fValue = ( double )( oButton.getX ( ) - iX ) / ( iWidth - oButton.getWidth ( ) ) * ( fMax - fMin );		
																		
		while ( SDL_PollEvent ( &oEvent ) )
		{
			switch ( oEvent.type )
			{
				case SDL_MOUSEBUTTONUP:
					mouseUp = true;
					break;
			}
		}
		
		refresh ( );																																																
										
		SDL_Delay ( 2 );
	}
}
