#ifndef _CGADGETSLIDER_H_
#define _CGADGETSLIDER_H_

#include <iostream>
#include <sstream>
#include <cmath>
#include <SDL/SDL.h>

#include "../globalcode/code_sdlgfx.cpp"
#include "cGadgetButton.h"

using namespace std;

class cGadgetSlider
{
	private:
		float fMin, fMax, fValue;		
		
		int iX, iY, iWidth, iHeight;	
		
		int iEventMouseCoordX, iEventMouseCoordY; /* Last registered mouse coords */
			
		string sDirection;
		
		SDL_Surface* oSurface;
		
		void mainLoop ( );
		
		cGadgetButton oButton;
		
	public:
	
		cGadgetSlider ( );
		~cGadgetSlider ( );
		
		void setActive ( ); /* <- starts the mainloop -- owns mouse */
		void setDirection ( string direction ); /* Y or X */
		void setDisplaySurface ( SDL_Surface* surface ); /* Where to output to */
		void setButtonRect ( SDL_Rect rect ); /* Set the size of the button to slide */
		void setSliderRect ( SDL_Rect rect ); /* Set the scroll area */
		void setScope ( float min, float max ); /* Set the scope */
		void setValue ( float value );
		void refresh ( );
		
		bool isMouseOver ( int x, int y );				
		
		float getValue ( );
		
};

#endif
