#include "cBrush.h"

cBrush::cBrush ( )
{
	fPI = 3.14159265358979323846264f;
	fRAD = fPI / 180.0f;		
	
	iPower = 255;
	
	sDrawMode = "normal";	
	
	iBrushSize = 1;	
	
	bFeather = false;
	bAntialias = false;				
}

cBrush::~cBrush ( ){}

/*
	The "action" function is the brain of the brush tool.
	Everything central happens here - directives, usage of
	other functions etc... 
*/
void cBrush::Draw ( cImage* canvas, SDL_Surface* window, double x, double y, double velocity )
{	
	cImageColor mColor = { oColor->r, oColor->g, oColor->b, oColor->a };
	
	double dBrushRad = ( double )iBrushSize / 2;	
	
	// Max velocity				
	if ( velocity > 6 )
		velocity = 6;
	
	/* Draws a line between prev coords and current coordinates and this */
	if ( sDrawMode == "normal" )
	{									
		if ( iBrushSize > 1 )
		{
			int c, d, dist;					
			
			for ( d = - iBrushSize; d <= iBrushSize; d ++ )
				for ( c = - iBrushSize; c <= iBrushSize; c ++ )
				{	
					dist = ( int )sqrt ( ( double )( c * c ) + ( double )( d * d ) );								
					
					if ( dist <= iBrushSize / 2 )
					{		
						/*
							Shall we do feathering?
						*/							
						
						if ( bFeather )
						{							
							cImageColor tempCol = canvas->getPixel ( c + ( int )x, d + ( int )y );							
																							
							double dFeather = 1 + dBrushRad - ( dBrushRad - dist );
							
							tempCol.r -= ( int )( ( ( double )( tempCol.r - mColor.r ) / dFeather ) / 255 * iPower );
							tempCol.g -= ( int )( ( ( double )( tempCol.g - mColor.g ) / dFeather ) / 255 * iPower );
							tempCol.b -= ( int )( ( ( double )( tempCol.b - mColor.b ) / dFeather ) / 255 * iPower );
							tempCol.a -= ( int )( ( ( double )( tempCol.a - mColor.a ) / dFeather ) / 255 * iPower );
							
							if ( tempCol.r < 0 ){ tempCol.r = 0; }
							if ( tempCol.g < 0 ){ tempCol.g = 0; }
							if ( tempCol.b < 0 ){ tempCol.b = 0; }
							if ( tempCol.a < 0 ){ tempCol.a = 0; }
							if ( tempCol.r > 255 ){ tempCol.r = 255; }
							if ( tempCol.g > 255 ){ tempCol.g = 255; }
							if ( tempCol.b > 255 ){ tempCol.b = 255; }
							if ( tempCol.a > 255 ){ tempCol.a = 255; }																					
																																																		
							canvas->putPixel ( c + ( int )x, d + ( int )y, &tempCol );
						}
						else
						{						
							if ( bAntialias & dist == dBrushRad & velocity != 0  )
							{								
								// Convert position to 0-0.9
								double xS = x - ( int )x;
								double yS = y - ( int )y;																		
								
								for ( int mx = 0; mx <= ceil ( yS ); mx++ )
								{
									for ( int my = 0; my <= ceil ( xS ); my++ )
									{																				
										cImageColor ResuCol = canvas->getPixel ( ( int )x + c + mx, ( int )y + d + my );
										
										double diffx = xS - mx;
										double diffy = yS - my;
										
										double dist = sqrt ( ( diffx * diffx ) + ( diffy * diffy ) );
				
										double Power = 1 + ( dist * velocity );																																			
									
										ResuCol.r -= ( int )( ( ( double )( ResuCol.r - mColor.r ) / Power ) / 255 * iPower );
										ResuCol.g -= ( int )( ( ( double )( ResuCol.g - mColor.g ) / Power ) / 255 * iPower );
										ResuCol.b -= ( int )( ( ( double )( ResuCol.b - mColor.b ) / Power ) / 255 * iPower );
										ResuCol.a -= ( int )( ( ( double )( ResuCol.a - mColor.a ) / Power ) / 255 * iPower );
										
										canvas->putPixel ( ( int )x + c + mx, ( int )y + d + my, ResuCol );										
									}
								}																
							}
							else
							{						
								cImageColor ResuCol = canvas->getPixel ( c + ( int )x, d + ( int )y );
								
								ResuCol.r -= ( int )( ( double )( ResuCol.r - mColor.r ) / 255 * iPower );
								ResuCol.g -= ( int )( ( double )( ResuCol.g - mColor.g ) / 255 * iPower );
								ResuCol.b -= ( int )( ( double )( ResuCol.b - mColor.b ) / 255 * iPower );
								ResuCol.a -= ( int )( ( double )( ResuCol.a - mColor.a ) / 255 * iPower );
								
								canvas->putPixel ( c + ( int )x, d + ( int )y, ResuCol );
							}
						}
					}
				}
		}
		else
		{
			if ( bAntialias )
			{				
				// Convert position to 0-0.9
				double xS = x - ( int )x;
				double yS = y - ( int )y;																		
				
				for ( int mx = 0; mx <= ceil ( yS ); mx++ )
				{
					for ( int my = 0; my <= ceil ( xS ); my++ )
					{
						double diffx = xS - mx;
						double diffy = yS - my;
						double dist = sqrt ( ( diffx * diffx ) + ( diffy * diffy ) );

						double Power = 1 + ( dist * velocity );
									
						cImageColor ResuCol = canvas->getPixel ( ( int )x + mx, ( int )y + my );
						
						ResuCol.r -= ( int )( ( ( double )( ResuCol.r - mColor.r ) / Power ) / 255 * iPower );
						ResuCol.g -= ( int )( ( ( double )( ResuCol.g - mColor.g ) / Power ) / 255 * iPower );
						ResuCol.b -= ( int )( ( ( double )( ResuCol.b - mColor.b ) / Power ) / 255 * iPower );
						ResuCol.a -= ( int )( ( ( double )( ResuCol.a - mColor.a ) / Power ) / 255 * iPower );
						
						canvas->putPixel ( ( int )x + mx, ( int )y + my, ResuCol );												
					}
				}								
			}
			else
			{				
				cImageColor ResuCol = canvas->getPixel ( ( int )x, ( int )y );
				
				ResuCol.r -= ( int )( ( double )( ResuCol.r - mColor.r ) / 255 * iPower );
				ResuCol.g -= ( int )( ( double )( ResuCol.g - mColor.g ) / 255 * iPower );
				ResuCol.b -= ( int )( ( double )( ResuCol.b - mColor.b ) / 255 * iPower );
				ResuCol.a -= ( int )( ( double )( ResuCol.a - mColor.a ) / 255 * iPower );			
				
				canvas->putPixel ( ( int )x, ( int )y, ResuCol );
			}
		}
	}
	if ( sDrawMode == "erase" )
	{							
		cImageColor eraseCol; eraseCol.r = 100; eraseCol.g = 100; eraseCol.b = 100; eraseCol.a = 0;
			
		if ( iBrushSize > 1 )
		{
			int c, d, dist;					
			
			for ( d = - iBrushSize; d <= iBrushSize; d ++ )
				for ( c = - iBrushSize; c <= iBrushSize; c ++ )
				{	
					dist = ( int )sqrt ( ( double )( c * c ) + ( double )( d * d ) );								
					
					if ( dist <= iBrushSize / 2 )
					{									
						if ( bFeather )
						{
							// Feather routine							
							cImageColor tempCol = canvas->getPixel ( c + ( int )x, d + ( int )y );
							
							if ( tempCol.a != 0 )
							{																
								double dFeather = 1 + dBrushRad - ( dBrushRad - dist );
								
								tempCol.r -= ( int )( ( ( double )( tempCol.r - eraseCol.r ) / dFeather ) / 255 * iPower );
								tempCol.g -= ( int )( ( ( double )( tempCol.g - eraseCol.g ) / dFeather ) / 255 * iPower );
								tempCol.b -= ( int )( ( ( double )( tempCol.b - eraseCol.b ) / dFeather ) / 255 * iPower );
								tempCol.a -= ( int )( ( ( double )( tempCol.a - eraseCol.a ) / dFeather ) / 255 * iPower );
								
								if ( tempCol.r < 0 ){ tempCol.r = 0; }
								if ( tempCol.g < 0 ){ tempCol.g = 0; }
								if ( tempCol.b < 0 ){ tempCol.b = 0; }
								if ( tempCol.a < 0 ){ tempCol.a = 0; }
								if ( tempCol.r > 255 ){ tempCol.r = 255; }
								if ( tempCol.g > 255 ){ tempCol.g = 255; }
								if ( tempCol.b > 255 ){ tempCol.b = 255; }
								if ( tempCol.a > 255 ){ tempCol.a = 255; }
																	
								canvas->putPixel ( c + ( int )x, d + ( int )y, &tempCol );
							}
						}
						else
						{						
							if ( bAntialias & dist == ( iBrushSize / 2 ) & velocity != 0 )
							{								
								// Convert position to 0-0.9
								double xS = x - ( int )x;
								double yS = y - ( int )y;																		
								
								for ( int mx = 0; mx <= ceil ( yS ); mx++ )
								{
									for ( int my = 0; my <= ceil ( xS ); my++ )
									{																				
										cImageColor ResuCol = canvas->getPixel ( ( int )x + c + mx, ( int )y + d + my );
										
										if (ResuCol.a != 0 )
										{
											double diffx = xS - mx;
											double diffy = yS - my;
											
											double dist = sqrt ( ( diffx * diffx ) + ( diffy * diffy ) );
					
											double Power = 1 + ( dist * velocity );																																			
										
											ResuCol.r -= ( int )( ( ( double )( ResuCol.r - eraseCol.r ) / Power ) / 255 * iPower );
											ResuCol.g -= ( int )( ( ( double )( ResuCol.g - eraseCol.g ) / Power ) / 255 * iPower );
											ResuCol.b -= ( int )( ( ( double )( ResuCol.b - eraseCol.b ) / Power ) / 255 * iPower );
											ResuCol.a -= ( int )( ( ( double )( ResuCol.a - eraseCol.a ) / Power ) / 255 * iPower );
											
											canvas->putPixel ( ( int )x + c + mx, ( int )y + d + my, ResuCol );																				
										}
									}
								}																
							}
							else
							{
								cImageColor ResuCol = canvas->getPixel ( c + ( int )x, d + ( int )y );
						
								ResuCol.r -= ( int )( ( double )( ResuCol.r - eraseCol.r ) / 255 * iPower );
								ResuCol.g -= ( int )( ( double )( ResuCol.g - eraseCol.g ) / 255 * iPower );
								ResuCol.b -= ( int )( ( double )( ResuCol.b - eraseCol.b ) / 255 * iPower );
								ResuCol.a -= ( int )( ( double )( ResuCol.a - eraseCol.a ) / 255 * iPower );
												
								canvas->putPixel ( c + ( int )x, d + ( int )y, ResuCol );
							}
						}
					}
				}
		}
		else
		{
			if ( bAntialias & velocity != 0 )
			{				
				// Convert position to 0-0.9
				double xS = x - ( int )x;
				double yS = y - ( int )y;																		
				
				for ( int mx = 0; mx <= ceil ( yS ); mx++ )
				{
					for ( int my = 0; my <= ceil ( xS ); my++ )
					{
						double diffx = xS - mx;
						double diffy = yS - my;
						double dist = sqrt ( ( diffx * diffx ) + ( diffy * diffy ) );

						double Power = 1 + ( dist * velocity );
									
						cImageColor ResuCol = canvas->getPixel ( ( int )x + mx, ( int )y + my );
						
						ResuCol.r -= ( int )( ( ( double )( ResuCol.r - eraseCol.r ) / Power ) / 255 * iPower );
						ResuCol.g -= ( int )( ( ( double )( ResuCol.g - eraseCol.g ) / Power ) / 255 * iPower );
						ResuCol.b -= ( int )( ( ( double )( ResuCol.b - eraseCol.b ) / Power ) / 255 * iPower );
						ResuCol.a -= ( int )( ( ( double )( ResuCol.a - eraseCol.a ) / Power ) / 255 * iPower );
						
						canvas->putPixel ( ( int )x + mx, ( int )y + my, ResuCol );												
					}
				}								
			}
			else
			{
				cImageColor ResuCol = canvas->getPixel ( ( int )x, ( int )y );
						
				ResuCol.r -= ( int )( ( double )( ResuCol.r - eraseCol.r ) / 255 * iPower );
				ResuCol.g -= ( int )( ( double )( ResuCol.g - eraseCol.g ) / 255 * iPower );
				ResuCol.b -= ( int )( ( double )( ResuCol.b - eraseCol.b ) / 255 * iPower );
				ResuCol.a -= ( int )( ( double )( ResuCol.a - eraseCol.a ) / 255 * iPower );
				
				canvas->putPixel ( ( int )x, ( int )y, ResuCol );
			}
		}
	}
	else if ( sDrawMode == "lighten" )
	{		
		cImageColor col;								
				
		if ( iBrushSize > 1 )
		{
			int c, d;
			double dist;				
									
			for ( d = - iBrushSize; d <= iBrushSize; d ++ )
				for ( c = - iBrushSize; c <= iBrushSize; c ++ )
				{	
					dist = ( int ) sqrt ( ( double )( c * c ) + ( double )( d * d ) );
					
					if ( dist <= iBrushSize / 2 )
					{
						col = canvas->getPixel ( c + ( int )x, d + ( int )y );					
																																
						// Todo - implement feathering on lighten
						if ( col.r < 255 )
							col.r += 1;						
						if ( col.g < 255 )
							col.g += 1;
						if ( col.b < 255 )
							col.b += 1;	
						
						canvas->putPixel ( c + ( int )x, d + ( int )y, &col );						
					}
				}
		}
		else
		{
			col = canvas->getPixel ( ( int )x, ( int )y );			
									
			if ( col.r < 255 )
				col.r += 1;						
			if ( col.g < 255 )
				col.g += 1;
			if ( col.b < 255 )
				col.b += 1;
		
			canvas->putPixel ( ( int )x, ( int )y, &col );
		}	
	}
	else if ( sDrawMode == "darken" )
	{		
		cImageColor col;				
			
		if ( iBrushSize > 1 )
		{
			int c, d, dist;
			
			for ( d = - iBrushSize; d <= iBrushSize; d ++ )
				for ( c = - iBrushSize; c <= iBrushSize; c ++ )
				{	
					dist = ( int ) sqrt ( ( double )( c * c ) + ( double )( d * d ) );																
					
					if ( dist <= iBrushSize / 2 )
					{									
						col = canvas->getPixel ( c + ( int )x, d + ( int )y );					
						
						// Todo: implement feather on lighten
						
						if ( col.r > 0 )
							col.r -= 1;
						if ( col.g > 0 )
							col.g -= 1;
						if ( col.b > 0 )
							col.b -= 1;																									
																									
						canvas->putPixel ( c + ( int )x, d + ( int )y, &col );
					}
				}
		}
		else
		{															
			col = canvas->getPixel ( ( int )x, ( int )y );					
														
			if ( col.r > 0 )
				col.r -= 1;
			if ( col.g > 0 )
				col.g -= 1;
			if ( col.b > 0 )
				col.b -= 1;
			
			canvas->putPixel ( ( int )x, ( int )y, &col );
		}	
	}
	else if ( sDrawMode == "smudge" )
	{		
		cImageColor col;
		cImageColor smudgeCol;
		
								
		if ( iBrushSize > 1 )
		{
			int c, d;						
			double dist;				
			
			for ( d = - iBrushSize; d <= iBrushSize; d ++ )
				for ( c = - iBrushSize; c <= iBrushSize; c ++ )
				{									
					dist = ( int ) sqrt ( ( double )( c * c ) + ( double )( d * d ) );
					if ( dist <= iBrushSize / 2 )
					{				
						/* The color which was on the spot before we coloured it */
						smudgeCol = canvas->getPixel ( c + ( int )x, d + ( int )y );
						
						/* The color in front of the pointer in the direction we're painting */
						col = canvas->getPixel ( c + ( int )x, d + ( int )y );
					
						/* The midpoint between the color in front and the color in the back */
						smudgeCol.r -= ( int )( ( double )( smudgeCol.r - col.r ) / 4 );
						smudgeCol.g -= ( int )( ( double )( smudgeCol.g - col.g ) / 4 ); 
						smudgeCol.b -= ( int )( ( double )( smudgeCol.b - col.b ) / 4 ); 
						smudgeCol.a -= ( int )( ( double )( smudgeCol.a - col.a ) / 4 );																					
						
						if ( bFeather )
						{									
							// Feather routine																																						
							cImageColor tempCol = canvas->getPixel ( c + ( int )x, d + ( int )y );																		
							
							tempCol.r += ( int )( ( double )( iBrushSize - dist ) / iBrushSize * ( ( double )( smudgeCol.r - tempCol.r ) / 6 ) );
							tempCol.g += ( int )( ( double )( iBrushSize - dist ) / iBrushSize * ( ( double )( smudgeCol.g - tempCol.g ) / 6 ) );
							tempCol.b += ( int )( ( double )( iBrushSize - dist ) / iBrushSize * ( ( double )( smudgeCol.b - tempCol.b ) / 6 ) );
							tempCol.a += ( int )( ( double )( iBrushSize - dist ) / iBrushSize * ( ( double )( smudgeCol.a - tempCol.a ) / 6 ) );									
							if ( tempCol.r < 0 ){ tempCol.r = 0; }
							if ( tempCol.g < 0 ){ tempCol.g = 0; }
							if ( tempCol.b < 0 ){ tempCol.b = 0; }
							if ( tempCol.a < 0 ){ tempCol.a = 0; }
							if ( tempCol.r > 255 ){ tempCol.r = 255; }
							if ( tempCol.g > 255 ){ tempCol.g = 255; }
							if ( tempCol.b > 255 ){ tempCol.b = 255; }
							if ( tempCol.a > 255 ){ tempCol.a = 255; }																			
							canvas->putPixel ( c + ( int )x, d + ( int )y, &tempCol );
						}
						else																																																	
							canvas->putPixel ( c + ( int )x, d + ( int )y, &smudgeCol );
					}
				}
		}
		else
		{
			
			/* The color which was on the spot before we coloured it */
			smudgeCol = canvas->getPixel ( ( int )x, ( int )y );				 
						
			/* The color in front of the pointer in the direction we're painting */
			col = canvas->getPixel ( ( int )x, ( int )y );
			
			/* The midpoint between the color in front and the color in the back */
			smudgeCol.r -= ( int )( ( double )( smudgeCol.r - col.r ) / 4 );
			smudgeCol.g -= ( int )( ( double )( smudgeCol.g - col.g ) / 4 ); 
			smudgeCol.b -= ( int )( ( double )( smudgeCol.b - col.b ) / 4 ); 
			smudgeCol.a -= ( int )( ( double )( smudgeCol.a - col.a ) / 4 );
			
			canvas->putPixel ( ( int )x, ( int )y, &smudgeCol );
		}	
	}					
	else if ( sDrawMode == "blur" )
	{		
		cImageColor col[ 4 ];
		cImageColor blurCol;
		int a, tR, tG, tB, tA;
									
		if ( iBrushSize > 1 )
		{
			int c, d, dist;																																				
			
			for ( d = -iBrushSize; d <= iBrushSize; d ++ )
				for ( c = -iBrushSize; c <= iBrushSize; c ++ )
				{									
					dist = ( int ) sqrt ( ( double )( c * c ) + ( double )( d * d ) );
					if ( dist <= iBrushSize / 2 )
					{	
						/* The color which was on the spot before we coloured it */
						blurCol = canvas->getPixel ( c + ( int )x, d + ( int )y );
						
						/* The color in front of the pointer in the direction we're painting */
						int testOffset;									
						testOffset = c - 1 + ( int )x; 
						if ( testOffset < 0 )	testOffset = 0;						
						col[ 0 ] = canvas->getPixel ( testOffset, d + ( int )y );									
						
						testOffset = c + 1 + ( int )x; 
						if ( testOffset >= canvas->getWidth ( ) ) testOffset = canvas->getWidth ( ) - 1;
						col[ 1 ] = canvas->getPixel ( testOffset, d + ( int )y );
						
						testOffset = d - 1 + ( int )y; 
						if ( testOffset < 0 ) testOffset = 0;
						col[ 2 ] = canvas->getPixel ( c + ( int )x, testOffset );
						
						testOffset = d + 1 + ( int )y; 
						if ( testOffset >= canvas->getHeight ( ) ) testOffset = canvas->getHeight ( ) - 1;
						col[ 3 ] = canvas->getPixel ( c + ( int )x, testOffset );
						
						/* Make average color value */
						tR = 0; tG = 0; tB = 0; tA = 0;
						for ( a = 0; a < 4; a++ )
						{
							tR += col[ a ].r;
							tG += col[ a ].g;
							tB += col[ a ].b;
							tA += col[ a ].a;
						}
						
						/* 
							Make average of four registered colors:
						*/
						
						tR = ( int )( ( double )tR / 4 );
						tG = ( int )( ( double )tG / 4 );
						tB = ( int )( ( double )tB / 4 );
						tA = ( int )( ( double )tA / 4 );
						
						/* 
							Make blurCol from the average by blending
						*/									
						blurCol.r -= ( int )( ( blurCol.r - tR ) );
						blurCol.g -= ( int )( ( blurCol.g - tG ) ); 
						blurCol.b -= ( int )( ( blurCol.b - tB ) ); 
						blurCol.a -= ( int )( ( blurCol.a - tA ) );		
						
						
						if ( bFeather )
						{									
							// Feather routine																																						
							cImageColor tempCol = canvas->getPixel ( c + ( int )x, d + ( int )y );																		
							
							double dFeather = 1 + dBrushRad - ( dBrushRad - dist );
								
							tempCol.r -= ( int )( ( ( double )( tempCol.r - blurCol.r ) / dFeather ) / 255 * iPower );
							tempCol.g -= ( int )( ( ( double )( tempCol.g - blurCol.g ) / dFeather ) / 255 * iPower );
							tempCol.b -= ( int )( ( ( double )( tempCol.b - blurCol.b ) / dFeather ) / 255 * iPower );
							tempCol.a -= ( int )( ( ( double )( tempCol.a - blurCol.a ) / dFeather ) / 255 * iPower );
							
							if ( tempCol.r < 0 ){ tempCol.r = 0; }
							if ( tempCol.g < 0 ){ tempCol.g = 0; }
							if ( tempCol.b < 0 ){ tempCol.b = 0; }
							if ( tempCol.a < 0 ){ tempCol.a = 0; }
							if ( tempCol.r > 255 ){ tempCol.r = 255; }
							if ( tempCol.g > 255 ){ tempCol.g = 255; }
							if ( tempCol.b > 255 ){ tempCol.b = 255; }
							if ( tempCol.a > 255 ){ tempCol.a = 255; }																			
							
							canvas->putPixel ( c + ( int )x, d + ( int )y, &tempCol );
						}
						else	
						{	
							if ( bAntialias & dist == ( iBrushSize / 2 ) & velocity != 0 )
							{								
								// Convert position to 0-0.9
								double xS = x - ( int )x;
								double yS = y - ( int )y;																		
								
								for ( int mx = 0; mx <= ceil ( yS ); mx++ )
								{
									for ( int my = 0; my <= ceil ( xS ); my++ )
									{																				
										cImageColor ResuCol = canvas->getPixel ( ( int )x + c + mx, ( int )y + d + my );
																				
										double diffx = xS - mx;
										double diffy = yS - my;
										
										double dist = sqrt ( ( diffx * diffx ) + ( diffy * diffy ) );
				
										double Power = 1 + ( dist * velocity );																																			
									
										ResuCol.r -= ( int )( ( ( double )( ResuCol.r - blurCol.r ) / Power ) / 255 * iPower );
										ResuCol.g -= ( int )( ( ( double )( ResuCol.g - blurCol.g ) / Power ) / 255 * iPower );
										ResuCol.b -= ( int )( ( ( double )( ResuCol.b - blurCol.b ) / Power ) / 255 * iPower );
										ResuCol.a -= ( int )( ( ( double )( ResuCol.a - blurCol.a ) / Power ) / 255 * iPower );
										
										canvas->putPixel ( ( int )x + c + mx, ( int )y + d + my, ResuCol );																				
									}
								}																
							}
							else
							{								
								cImageColor ResuCol = canvas->getPixel ( c + ( int )x, d + ( int )y );
				
								ResuCol.r -= ( int )( ( double )( ResuCol.r - blurCol.r ) / 255 * iPower );
								ResuCol.g -= ( int )( ( double )( ResuCol.g - blurCol.g ) / 255 * iPower );
								ResuCol.b -= ( int )( ( double )( ResuCol.b - blurCol.b ) / 255 * iPower );
								ResuCol.a -= ( int )( ( double )( ResuCol.a - blurCol.a ) / 255 * iPower );
								
								canvas->putPixel ( c + ( int )x, d + ( int )y, ResuCol );
							}
						}
					}
				}
		}
		else
		{
			
			/* The color which was on the spot before we coloured it */
			blurCol = canvas->getPixel ( ( int )x, ( int )y );				 
						
			/* The color in front of the pointer in the direction we're painting */
			col[ 0 ] = canvas->getPixel ( ( int )x - 1, ( int )y );
			col[ 1 ] = canvas->getPixel ( ( int )x + 1, ( int )y );
			col[ 2 ] = canvas->getPixel ( ( int )x, ( int )y - 1 );
			col[ 3 ] = canvas->getPixel ( ( int )x, ( int )y + 1 );
			
			/* Make blurCol the average */
			for ( a = 0; a < 4; a++ )
			{
				blurCol.r -= ( int )( ( blurCol.r - col[ a ].r ) / 4 );
				blurCol.g -= ( int )( ( blurCol.g - col[ a ].g ) / 4 ); 
				blurCol.b -= ( int )( ( blurCol.b - col[ a ].b ) / 4 ); 
				blurCol.a -= ( int )( ( blurCol.a - col[ a ].a ) / 4 );
			}
			
			if ( bAntialias & velocity != 0 )
			{				
				// Convert position to 0-0.9
				double xS = x - ( int )x;
				double yS = y - ( int )y;																		
				
				for ( int mx = 0; mx <= ceil ( yS ); mx++ )
				{
					for ( int my = 0; my <= ceil ( xS ); my++ )
					{
						double diffx = xS - mx;
						double diffy = yS - my;
						double dist = sqrt ( ( diffx * diffx ) + ( diffy * diffy ) );

						double Power = 1 + ( dist * velocity );
									
						cImageColor ResuCol = canvas->getPixel ( ( int )x + mx, ( int )y + my );
						
						ResuCol.r -= ( int )( ( ( double )( ResuCol.r - blurCol.r ) / Power ) / 255 * iPower );
						ResuCol.g -= ( int )( ( ( double )( ResuCol.g - blurCol.g ) / Power ) / 255 * iPower );
						ResuCol.b -= ( int )( ( ( double )( ResuCol.b - blurCol.b ) / Power ) / 255 * iPower );
						ResuCol.a -= ( int )( ( ( double )( ResuCol.a - blurCol.a ) / Power ) / 255 * iPower );
						
						canvas->putPixel ( ( int )x + mx, ( int )y + my, ResuCol );												
					}
				}								
			}
			else
			{
				cImageColor ResuCol = canvas->getPixel ( ( int )x, ( int )y );
				
				ResuCol.r -= ( int )( ( double )( ResuCol.r - blurCol.r ) / 255 * iPower );
				ResuCol.g -= ( int )( ( double )( ResuCol.g - blurCol.g ) / 255 * iPower );
				ResuCol.b -= ( int )( ( double )( ResuCol.b - blurCol.b ) / 255 * iPower );
				ResuCol.a -= ( int )( ( double )( ResuCol.a - blurCol.a ) / 255 * iPower );
				
				canvas->putPixel ( ( int )x, ( int )y, ResuCol );
			}
		}	
	}				
				
	// Draw an outline on the real-time screen															
	if ( iBrushSize > 1 )
	{																	
		if ( sMouseMode == "off" )
		{	
			cImageColor tempPixel = mColor; tempPixel.a = 255;
			
			int c, d, dist;								
			
			for ( d = - iBrushSize; d <= iBrushSize; d ++ )
			{
				for ( c = - iBrushSize; c <= iBrushSize; c ++ )
				{	
					dist = ( int ) sqrt ( ( double )( c * c ) + ( double )( d * d ) );
					if ( dist < iBrushSize & dist > iBrushSize - 2 )
					{							
						canvas->putPixel ( 
							( int )( x + c ), 
							( int )( y + d ), 
						&tempPixel, window );																
					}						
				}
			}							
		}
	}			
}		

void cBrush::setDrawMode ( string drawmode )
{
	sDrawMode = drawmode;
}		

string cBrush::getDrawMode ( )
{
	return sDrawMode;		
}		

void cBrush::sendQuery ( string query )
{
	if ( query == "sizePlus" )
	{
		if ( iBrushSize < 100 )			
			iBrushSize += 1;
		else
			iBrushSize = 100;
	}
	else if ( query == "sizeMinus" )
	{
		if ( iBrushSize > 1 )
			iBrushSize -= 1;
		else
			iBrushSize = 1;
	}
	if ( query == "togglefeather" )
	{
		if ( bFeather )
			bFeather = false;
		else
			bFeather = true;
	}
	if ( query == "toggleantialias" )
	{
		if ( bAntialias )
			bAntialias = false;
		else
			bAntialias = true;
	}
}

int cBrush::getSize ( )
{
	return iBrushSize;
}

int cBrush::getRadius ( )
{
	return ( int )( iBrushSize / 2 );
}

cImageColor cBrush::getCurrentColor ( )
{
	return *oColor;
}

void cBrush::setColorPointer ( cImageColor* color )
{
	oColor = color;
}

void cBrush::setPower ( int power )
{
	if ( power >= 0 & power <= 255 )
	{
		iPower = power;
	}
}

int cBrush::getPower ( )
{
	return iPower;
}
