#ifndef _CBRUSH_H_
#define _CBRUSH_H_

#include <SDL/SDL.h>
#include <string>
#include <cmath>

#include "cImage.h"
	
using namespace std;
	
class cBrush
{
	private:
		
		float fPI, fRAD;
		
		string sMouseMode, sDrawMode;	
		
		int iBrushSize;
		
		bool bAntialias, bFeather;
		
		cCoords ActionCoords;		
		
		cImageColor* oColor;
		
		int iPower;
		
	public:

		cBrush ( );			
		~cBrush ( );			
					
		void Draw ( cImage* canvas, SDL_Surface* window, double x, double y, double velocity );
		
		void sendQuery ( string query );			
		void setDrawMode ( string drawmode );	
		void setColorPointer ( cImageColor* color );
		
		string getDrawMode ( );						
		
		int getSize ( );
		int getRadius ( );
		int getPower ( );
		
		void setPower ( int power );
		
		cImageColor cBrush::getCurrentColor ( );	
};

#endif
