
	#ifndef _CFILEIO_H_
	#define _CFILEIO_H_
	
	#include <string>
	#include <sstream>
	#include <png.h>
	#include <map>	
	#include <fstream>
	#include "SDL/SDL.h"
	#include "SDL/SDL_image.h"
	
	#include "cImage.h"	
	
	#include "../globalcode/code_libpng.cpp"
	
	using namespace std;		
	
	class cFileIO
	{
		private:
			string fileName;
			int width; 
			int height; 
			int frames;
			int layers;
			bool initialized;
			map < int, SDL_Surface* > surfaces;
			
		public:
			cFileIO ( );
			~cFileIO ( );
			void setFilename ( string filename );
			bool getFilename ( );
			void setWidth ( int number );
			void setHeight ( int number );
			void setFrames ( int number );
			void setLayers ( int number );
			int getWidth ( );
			int getHeight ( );
			int getFrames ( );
			int getLayers ( );
			void copyFrameBuffer ( int frameoffset, SDL_Surface* surface );
			bool importFile ( cImage* image );			
 			bool exportFile ( SDL_Surface* surf, string FORMAT );			
			void copySurface ( SDL_Surface* surface, int number );			
			bool save ( );
			bool load ( );
	};
	
	#endif
