
	#include "cPanelLayers.h"
	
	cPanelLayers::cPanelLayers ( )
	{
		this->height = 0;
		this->currentlayer = 0;
	}
	
	cPanelLayers::~cPanelLayers ( )
	{
	}
	
	void cPanelLayers::setScreenHeight ( int height )
	{
		this->height = height;
	}
	
	void cPanelLayers::redraw ( SDL_Surface* screen )
	{
		/* Draw the layers */
		cImageColor colGrey; colGrey.r = 30; colGrey.g = 30; colGrey.b = 30; colGrey.a = 255;
		cImageColor colWhite; colWhite.r = 225; colWhite.g = 225; colWhite.b = 225; colWhite.a = 255;
		int a;		
		int offsety = this->height - ( this->height / 2 );
		int piece = ( this->height / 2 ) / this->layernum; int count; count = 0;
		for ( a = offsety; a < screen->h; a += piece )
		{
			if ( count == this->currentlayer )
				this->drawColorRect ( 0, a + 1, 16, piece - 1, screen, colWhite );
			else
				this->drawColorRect ( 0, a + 1, 16, piece - 1, screen, colGrey );
			
			count++;
		}
	}
	
	void cPanelLayers::drawColorRect ( int x, int y, int w, int h, SDL_Surface* canvas, cImageColor color )
	{
		Uint32 col = SDL_MapRGB ( canvas->format, 50, 50, 50 );
		Uint32 colp = SDL_MapRGB ( canvas->format, ( char )color.r, ( char )color.g, ( char )color.b );
		SDL_Rect rect, rect2;
		rect.x = x; rect.y = y; rect.w = w; rect.h = h;
		rect2.x = x + 1; rect2.y = y + 1; rect2.w = w - 2; rect2.h = h - 2;
		SDL_FillRect( canvas, &rect, col );
		SDL_FillRect( canvas, &rect2, colp );
	}
	
	int cPanelLayers::getLayer ( int coordinate )
	{
		float offsety = this->height - ( this->height / 2 );
		float area = ( this->height / 2 );		
		float result = ( coordinate - offsety ) / area * this->layernum;
		this->currentlayer = ( int )result;
		result += 1.0;				
		return ( int )result;
	}
	
	void cPanelLayers::setLayerNum ( int num )
	{	
		this->currentlayer = num;		
	}
	
	void cPanelLayers::setLayers ( int num )
	{
		this->layernum = num;
		this->currentlayer = 0;
	}
