
	#include "cPanelPalette.h"
	
	cPanelPalette::cPanelPalette ( )
	{
		int palette[ 32 ][ 4 ] = 
		{ 
			{ 10, 120, 0, 255 }, 
			{ 255, 255, 255, 255 },
			{ 205, 205, 205, 255 }, 
			{ 155, 155, 155, 255 }, 
			{ 105, 105, 105, 255 }, 
			{ 55, 55, 55, 255 }, 
			{ 5, 5, 5, 255 }, 
			{ 0, 0, 0, 255 }, 
			{ 255, 0, 0, 255 }, 
			{ 200, 0, 0, 255 }, 			
			{ 150, 0, 0, 255 }, 
			{ 100, 0, 0, 255 }, 
			{ 50, 0, 0, 255 }, 
			{ 0, 255, 0, 255 }, 
			{ 0, 200, 0, 255 }, 
			{ 0, 150, 0, 255 }, 
			{ 0, 100, 0, 255 }, 
			{ 0, 50, 0, 255 }, 
			{ 0, 0, 255, 255 }, 
			{ 0, 0, 200, 255 }, 			
			{ 0, 0, 150, 255 }, 
			{ 0, 0, 100, 255 }, 
			{ 0, 0, 50, 255 }, 
			{ 250, 210, 180, 255 }, 
			{ 160, 140, 100, 255 }, 
			{ 100, 200, 0, 255 }, 
			{ 255, 255, 0, 255 }, 
			{ 250, 190, 0, 255 }, 
			{ 80, 70, 0, 255 }, 
			{ 100, 120, 145, 255 }, 			
			{ 200, 220, 240, 255 }, 
			{ 250, 0, 250, 255 }			
		};
	
		int a; for ( a = 0; a < 32; a++ )
		{			
			mPalette[ a ].r = palette[ a ][ 0 ];
			mPalette[ a ].g = palette[ a ][ 1 ];
			mPalette[ a ].b = palette[ a ][ 2 ];
			mPalette[ a ].a = palette[ a ][ 3 ];
		}
				
		oCurrentColor = mPalette[ 0 ];						
	}
	
	cPanelPalette::~cPanelPalette ( )
	{
 		mPalette.clear ( );
	}
	
	void cPanelPalette::redraw ( SDL_Surface* canvas )
	{
		/* The rects of the palette */
		double steps; steps = canvas->h / 32.0;
		int b; b = 0;
		
		iPaletteHeight = canvas->h;										
		
		Uint32 Dark = SDL_MapRGBA ( canvas->format, 0, 0, 0, 255 );
		SDL_Rect rect = { canvas->w - 18, 0, 18, canvas->h };
		SDL_FillRect ( canvas, &rect, Dark );
		
		for ( double a = 0.0f; a < iPaletteHeight; a += steps  )
		{
			if ( b == iCurrentColor )
			{
				// Draw and set highlight == true
				drawColorRect ( canvas->w - 17, ( int )a + 1, 16, ( int )steps - 1, canvas, mPalette[ b ], true );
			}
			else
			{
				drawColorRect ( canvas->w - 17, ( int )a + 1, 16, ( int )steps - 1, canvas, mPalette[ b ], false );
			}
			b++;
		}			
		
		
	}	
	
	void cPanelPalette::drawColorRect ( int x, int y, int w, int h, SDL_Surface* canvas, cImageColor color, bool highlight )
	{
		Uint32 col;
		
		if ( highlight )
		{
			col = SDL_MapRGB ( canvas->format, 255, 255, 255 );
		}
		else
		{
			col = SDL_MapRGB ( canvas->format, 100, 100, 100 );
		}		
				
		Uint32 colp = SDL_MapRGB ( canvas->format, ( char )color.r, ( char )color.g, ( char )color.b );
		SDL_Rect rect, rect2;
		rect.x = x; rect.y = y; rect.w = w; rect.h = h;
		rect2.x = x + 1; rect2.y = y + 1; rect2.w = w - 2; rect2.h = h - 2;
		SDL_FillRect( canvas, &rect, col );
		SDL_FillRect( canvas, &rect2, colp );
	}
	
	/* Figure out which color is clicked and return it */
	void cPanelPalette::setColor ( int c )
	{				
		float sum;
		sum = ( float )c / iPaletteHeight * 32.0f;	
		oCurrentColor = mPalette[ ( int )sum ];
		iCurrentColor = ( int )sum;
	}
	
	cImageColor cPanelPalette::getColor ( )
	{		
		return oCurrentColor;
	}
	
	cImageColor* cPanelPalette::getColorPointer ( )
	{
		return &oCurrentColor;
	}
