
	#ifndef _CTOOLCIRCLE_H_
	#define _CTOOLCIRCLE_H_
	
	#include <iostream>	
	#include <string>
	#include <cmath>
	#include <SDL/SDL.h>
	
	#include "cTool.h"	
	
	using namespace std;
	
	class cToolCircle : public cTool
	{			
		private:
			string sMousePhase, sMouseMode, sName, sDrawMode; // Dragging or applying?	
			
			int iX1, iX2, iY1, iY2;
			
			float fPI, fRAD;
						
			cImageColor oCurrentColor;
			
			cCoords oActionCoords;
			
			SDL_Rect oPrevRect;
			
			cBrush* oBrush;						
					
		public:
			
			string mouseMode;
			
			bool bDoFill;
			
			cToolCircle ( );			
			
			~cToolCircle ( );
			
			cCoords* Action ( cImage* canvas, SDL_Surface* window, int x, int y );
			
			cImageColor getCurrentColor ( );
			
			string getName ( );
			string getDrawMode ( );
						
			void sendQuery ( string query );
			void setMouseMode ( string value );
			void setDrawMode ( string drawmode );
			void setCurrentColor ( cImageColor color );
			void setBrush ( cBrush* brush );
			
			int getSize ();	
	};
	
	#endif
