
	#ifndef _CTOOLCLIPBRUSH_H_
	#define _CTOOLCLIPBRUSH_H_
	
	#include <iostream>	
	#include <string>
	#include <SDL/SDL.h>
	#include <cmath>
		
	#include "cTool.h"	
	
	#include "../main/cImage.h"
	
	using namespace std;
	
	class cToolClipbrush : public cTool
	{			
		private:
		
			string sMousePhase; // Dragging or applying?			
			
			Uint32 rmask, gmask, bmask, amask;
			
			int iX1, iX2, iY1, iY2;
			
			float fPI, fRAD;
			
			string sName, sDrawMode;
			
			cImageColor oCurrentColor;						
			
			cCoords oActionCoords;
			
			SDL_Rect oPrevRect;
			SDL_Surface* oClipBuffer;
			
			cImage oImage;
			
			bool bHasBuffer;
			bool bIsMoving;
			
			int iPrevX, iPrevY;
			
			void flipX ( );
			void flipY ( );
			void rotate ( );
			
			cBrush* oBrush;
			
		public:
			string sMouseMode;
						
			cToolClipbrush ( );
			
			~cToolClipbrush ( );
			
			cCoords* Action ( cImage* canvas, SDL_Surface* window, int x, int y );
			
			void setMouseMode ( string value );
			
			void setDrawMode ( string drawmode );
			
			void setCurrentColor ( cImageColor color );
			
			cImageColor getCurrentColor ( );
			
			string getName ( );
			
			string getDrawMode ( );
			
			void sendQuery ( string query );			
			
			int getSize ();
					
			void setBrush ( cBrush* brush );
	};
	
	#endif
