
	#include "cToolColorpicker.h"
	
	cToolColorpicker::cToolColorpicker ( )
	{		
		this->name = "colorpicker";
		this->mouseMode = "off";			
		this->drawMode = "normal";	
	}
	
	cToolColorpicker::~cToolColorpicker ( )
	{
		this->name = "";
		this->mouseMode = "";		
	}
	
	/*
		The "action" function is the brain of the brush tool.
		Everything central happens here - directives, usage of
		other functions etc... 
	*/
	cCoords* cToolColorpicker::Action ( cImage* canvas, SDL_Surface* window, int x, int y )
	{	
		// Prepare actioncoords for return to host function		
		this->ActionCoords.Activity = false;
		
		if ( this->mouseMode == "on" )
		{
			this->currentColor = canvas->getPixel ( x, y );
			this->ActionCoords.Activity = true;
			this->ActionCoords.x = 0;
			this->ActionCoords.y = 0;
			this->ActionCoords.w = 1;
			this->ActionCoords.h = 1;
		}
		
		return &this->ActionCoords;
	}
	
	void cToolColorpicker::setMouseMode ( string mode )
	{
		if ( mode == "off" or mode == "on" )
			this->mouseMode = mode;
		else 
			this->mouseMode = "off";
	}

	void cToolColorpicker::setDrawMode ( string drawmode )
	{
		this->drawMode = drawmode;
	}
	
	string cToolColorpicker::getName ( )
	{
		return this->name;
	}
	
	string cToolColorpicker::getDrawMode ( )
	{
		return this->drawMode;		
	}
	
	void cToolColorpicker::setCurrentColor ( cImageColor color )
	{
		this->currentColor = color;
	}
	
	void cToolColorpicker::sendQuery ( string query )
	{
		//		
	}
	
	int cToolColorpicker::getSize ( )
	{
		return 0;
	}
	
	cImageColor cToolColorpicker::getCurrentColor ( )
	{
		return this->currentColor;
	}
