
	#include "cToolFill.h"
	
	cToolFill::cToolFill ( )
	{
		this->fPI = 3.14159265358979323846264;
		this->fRAD = this->fPI / 180.0f;
		this->name = "fill";
		this->mouseMode = "off";
	}
	
	cToolFill::~cToolFill ( )
	{
		this->fPI = 0.0f;
		this->fRAD = 0.0f;
		this->name = "";
		this->mouseMode = "";
	}
	
	cCoords* cToolFill::Action ( cImage* canvas, SDL_Surface* window, int x, int y )
	{
		// Prepare actioncoords for return to host function
		this->ActionCoords.Activity = false;
		
		if ( this->mouseMode == "on" )
		{
			int maxWidth = canvas->getWidth ( );			
			int maxHeight = canvas->getHeight ( );			
						
			Uint32 color = canvas->getRawPixel ( x, y );																		
			Uint32 curcol = SDL_MapRGBA( ( canvas->getBuffer ( ) )->format, this->currentColor.r, this->currentColor.g, this->currentColor.b, this->currentColor.a );
						
			if ( !this->compareColors ( color, curcol ) )
			{			
				this->Fill ( x, y, color, canvas );
			}
			this->mouseMode = "off";
			
			// Set special return mode to refresh whole screen!
			this->ActionCoords.x = -999;
			this->ActionCoords.y = 0;
			this->ActionCoords.w = 0;
			this->ActionCoords.h = 0;
			this->ActionCoords.Activity = true;			
		}		
		return &this->ActionCoords;
	}
	
	inline void cToolFill::Fill ( int x, int y, Uint32 color, cImage* canvas )
	{			
		int maxWidth = canvas->getWidth ( );
		int maxHeight = canvas->getHeight ( );								
		
		int y1, y2, ey;			
		
		if ( x >= 0 & y >= 0 & x < maxWidth & y < maxHeight )
		{
			if ( this->compareColors ( canvas->getRawPixel ( x, y ), color ) )
			{								
				/* Find span top */
				y1 = y; y2 = y;			
				while ( this->compareColors ( canvas->getRawPixel ( x, y1 ), color ) & x >= 0 & y1 >= 0 & x < maxWidth & y1 < maxHeight )
					y1 --;
				while ( this->compareColors ( canvas->getRawPixel ( x, y2 ), color ) & x >= 0 & y2 >= 0 & x < maxWidth & y2 < maxHeight )
					y2 ++;
					
				/* Fill midpoint */				
				for ( ey = y1 + 1; ey < y2; ey++ )
					canvas->putPixel ( x, ey, this->currentColor );
					
				/* Fill recursively from left to right */
				for ( ey = y1 + 1; ey < y2; ey++ )
				{
					if ( this->compareColors ( canvas->getRawPixel ( x + 1, ey ), color ) & x + 1 >= 0 & ey >= 0 & x + 1 < maxWidth & ey < maxHeight )
						this->Fill ( x + 1, ey, color, canvas );
					if ( this->compareColors ( canvas->getRawPixel ( x - 1, ey ), color ) & x - 1 >= 0 & ey >= 0 & x - 1 < maxWidth & ey < maxHeight )
						this->Fill ( x - 1, ey, color, canvas );
				}
			}
		}		
	}				
	
	bool cToolFill::compareColors ( Uint32 color1, Uint32 color2 )
	{										;
			if ( color1 == color2 )				
				return true;
			else
				return false;
	}
	
	void cToolFill::setMouseMode ( string mode )
	{
		if ( mode == "off" or mode == "on" )
			this->mouseMode = mode;
		else
			this->mouseMode = "off";
	}

	void cToolFill::setDrawMode ( string drawmode )
	{
		this->drawMode = drawmode;
	}
	
	string cToolFill::getName ( )
	{
		return this->name;
	}
	
	string cToolFill::getDrawMode ( )
	{
		return this->drawMode;
	}
	
	void cToolFill::setCurrentColor ( cImageColor color )
	{
		this->currentColor = color;
	}
	
	void cToolFill::sendQuery ( string query )
	{
		//
	}
	
	int cToolFill::getSize ( )
	{	
		return 0;
	}
	
	cImageColor cToolFill::getCurrentColor ( )
	{
		
	}
