
	#ifndef _CTOOLLINE_H_
	#define _CTOOLLINE_H_
	
	#include <iostream>	
	#include <string>
	#include <SDL/SDL.h>
	#include <cmath>
	
	#include "cTool.h"		
	
	using namespace std;
	
	class cToolLine : public cTool
	{			
		private:
			string sMousePhase, sName, sDrawMode, sMouseMode;
			
			int iX1, iX2, iY1, iY2;
			
			float fPI, fRAD;
			
			cImageColor oColor;
			
			cCoords oActionCoords;
			
			SDL_Rect oPrevRect;
			
			cBrush* oBrush;
			
		public:
			
			string mouseMode;
			
			cToolLine ( );
			
			~cToolLine ( );
			
			cCoords* Action ( cImage* canvas, SDL_Surface* window, int x, int y );
			
			void setMouseMode ( string value );
			
			void setDrawMode ( string drawmode );
			
			void setCurrentColor ( cImageColor color );
			
			cImageColor getCurrentColor ( );
			
			string getName ( );
			
			string getDrawMode ( );
			
			void sendQuery ( string query );			
			
			int getSize ();
			
			void setBrush ( cBrush* brush );
	};
	
	#endif
