
	#ifndef _CTOOLRECTANGLE_H_
	#define _CTOOLRECTANGLE_H_
	
	#include <iostream>	
	#include <string>
	#include <SDL/SDL.h>
	#include <cmath>
	
	#include "cTool.h"
	
	using namespace std;
	
	class cToolRectangle : public cTool
	{			
		private:
			
			string sMousePhase; // Dragging or applying?	
			
			int iX1, iX2, iY1, iY2;
			
			float fPI, fRAD;
			
			string sName, sDrawMode;
			
			cImageColor oCurrentColor;						
			
			cCoords oActionCoords;
			
			SDL_Rect oPrevRect;
			
			cBrush* oBrush;
			
		public:
			
			string sMouseMode;
			
			bool bDoFill;
			
			cToolRectangle ( );
			
			~cToolRectangle ( );
			
			cCoords* Action ( cImage* canvas, SDL_Surface* window, int x, int y );
			
			void setMouseMode ( string value );
			
			void setDrawMode ( string drawmode );
			
			void setCurrentColor ( cImageColor color );
			
			cImageColor getCurrentColor ( );
			
			string getName ( );
			
			string getDrawMode ( );
			
			void sendQuery ( string query );			
			
			int getSize ();
			
			void setBrush ( cBrush* brush );
	};
	
	#endif
